base/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path
from drf_spectacular.views import SpectacularAPIView, SpectacularSwaggerView

api_patterns = [
    path("public/", include("api.public.urls")),
    path("schema/", SpectacularAPIView.as_view(), name="schema"),
    path("docs/", SpectacularSwaggerView.as_view(), name="swagger-ui"),
]

urlpatterns = [
    path(f"{settings.BASE_URL}admin/", admin.site.urls),
    path(f"{settings.BASE_URL}api/", include(api_patterns)),
    path(f"{settings.BASE_URL}auth/", include("authentication.urls")),
    path(f"{settings.BASE_URL}submit/", include("submitter.urls")),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns.append(path("__debug__/", include("debug_toolbar.urls")))

submitter/urls.py
from django.contrib.auth.decorators import login_required
from django.urls import path

from .api_validation_views import (
    ValidateChebiName,
    ValidateSynonym,
    HtmxSubmitCompoundGetSources,
    GetChemicalDataFromMol,
    GetMassFromFormula,
    SpeciesSearch,
    ComponentSearch,
    GetSourceAccessionField,
)
from .views.profile import SubmitterHomeView, SubmitterProfileView
from .views.retrieve_compound import SubmitterEntityDetailView, SubmitterEntityListView
from .views.submit_compound import SubmitCompoundView
from .views.update_compound import (
    NamesUpdateView,
    HtmxUpdateCompoundGetSourceView,
    SubmitterCreateNameView,
    CompoundUpdateView,
    SubmitterCreateCrossReferenceView,
    SubmitterUpdateCrossReferenceView,
)

app_name = "submitter"

# All submitter views require login
# TODO: Can we move login_required decorator to base.urls?
urlpatterns = [
    path("", login_required(SubmitterHomeView.as_view()), name="dashboard"),
    path("new/", login_required(SubmitCompoundView.as_view()), name="submit-new"),
    path("profile/", login_required(SubmitterProfileView.as_view()), name="profile"),
    path("CHEBI:<pk>/", login_required(SubmitterEntityDetailView.as_view()), name="entity-detail"),
    path("CHEBI:<pk>/edit/", login_required(CompoundUpdateView.as_view()), name="edit-entity"),
    path("name/<pk>/update/", login_required(NamesUpdateView.as_view()), name="name-update"),
    path("CHEBI:<pk>/add-synonym/", login_required(SubmitterCreateNameView.as_view()), name="add-synonym"),
    path("CHEBI:<pk>/add-xref/", login_required(SubmitterCreateCrossReferenceView.as_view()), name="add-xref"),
    path("xref/<pk>/edit/", login_required(SubmitterUpdateCrossReferenceView.as_view()), name="update-xref"),
    path("my-submissions/", login_required(SubmitterEntityListView.as_view()), name="my-submissions"),
    # HTMX Views
    path("validate/name/", login_required(ValidateChebiName.as_view()), name="validate_chebi_name"),
    path(
        "validate/source/<str:form_type>/",
        login_required(HtmxSubmitCompoundGetSources.as_view()),
        name="validate_source",
    ),
    path("validate/synonym/", login_required(ValidateSynonym.as_view()), name="validate_synonym"),
    path(
        "validate/mol_to_chemical_data/", login_required(GetChemicalDataFromMol.as_view()), name="mol_to_chemical_data"
    ),
    path("validate/formula_to_mass/", login_required(GetMassFromFormula.as_view()), name="formula_to_mass"),
    path("validate/species/", login_required(SpeciesSearch.as_view()), name="species_search"),
    path("validate/component/", login_required(ComponentSearch.as_view()), name="component_search"),
    path(
        "validate/source_accession/",
        login_required(GetSourceAccessionField.as_view()),
        name="get_source_accession_field",
    ),
    path("htmx/get/source/", login_required(HtmxUpdateCompoundGetSourceView.as_view()), name="htmx_get_source"),
]

submitter/views/profile.py
from django.contrib.messages.views import SuccessMessageMixin
from django.urls import reverse_lazy
from django.views.generic import TemplateView, UpdateView

from chebi_models.models import User

from submitter.forms.update_forms import (
    SubmitterProfileForm,
)


class SubmitterHomeView(TemplateView):
    template_name = "submitter/dashboard.html"


class SubmitterProfileView(SuccessMessageMixin, UpdateView):
    model = User
    form_class = SubmitterProfileForm
    template_name = "submitter/profile.html"
    success_url = reverse_lazy("submitter:profile")
    success_message = "Profile has been updated"

    def get_object(self, queryset=None):
        return self.request.user

submitter/views/retrieve_compound.py
from django.contrib import messages
from django.http import Http404
from django.shortcuts import get_object_or_404
from django.views.generic import DetailView, ListView
from libRDChEBI.depiction import depict
from django.db.models import Q

from chebi_models.models import Compound


class SubmitterEntityListView(ListView):
    model = Compound
    template_name = "submitter/compound_list.html"
    paginate_by = 20
    ordering = "-pk"

    def get_queryset(self):
        qs = super().get_queryset().filter(created_by=self.request.user)
        search_keyword = self.request.GET.get("keyword")
        if search_keyword:
            qs = qs.filter(Q(name__icontains=search_keyword) | Q(chebi_accession__icontains=search_keyword))
        return qs


class SubmitterEntityDetailView(DetailView):
    model = Compound
    template_name = "submitter/compound-detail/index.html"

    def get_object(self, queryset=None):
        # Return parent object if it exists
        compound_obj = get_object_or_404(Compound.objects.all(), pk=self.kwargs.get("pk"))

        if (
            compound_obj.created_by != self.request.user
            and not compound_obj.children.filter(created_by=self.request.user).exists()
        ):
            # Return 404 if the current user did not create this entry or any of its children
            raise Http404

        if compound_obj.parent:
            messages.info(
                self.request,
                f"{compound_obj.chebi_accession} has been merged by ChEBI curators. You are now viewing details of "
                f"its parent entry.",
            )
            return compound_obj.parent
        return compound_obj

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["submitters"] = (
            Compound.objects.filter(pk__in=self.object.compound_with_children_ids, created_by__is_anonymous=False)
            .values_list("created_by__public_name", flat=True)
            .distinct()
        )
        context["compound_with_children"] = [self.object] + list(self.object.children.all().order_by("pk"))
        if self.object.default_structure:
            context["default_structure_svg"] = depict(
                self.object.default_structure.molfile, maxFontSize=50, width=400, height=400
            )
        return context

submitter/views/submit_compound.py
from django.contrib import messages
from django.shortcuts import redirect
from django.views.generic import FormView

from chebi_models.models import Compound, Names, DatabaseAccession, CompoundOrigins

from submitter.forms.submit_forms import (
    SubmitCompoundForm,
    NamesFormSet,
    DatabaseAccessionFormSet,
    ChemicalDataForm,
    CompoundOriginsFormSet,
)
from submitter.utils import (
    save_names_formset,
    save_database_accessions_formset,
    save_compound_origins_formset,
    get_default_submitter_status,
)


class SubmitCompoundView(FormView):
    model = Compound
    template_name = "submitter/submit.html"
    form_class = SubmitCompoundForm
    formset_class = NamesFormSet

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.chemical_data_form = None
        self.names_formset = None
        self.database_accession_formset = None
        self.compound_origins_formset = None

    def form_valid(self, form):
        """If the form is valid, redirect to entry detail page"""
        messages.success(self.request, "Entry has been submitted successfully")
        return redirect("submitter:entity-detail", pk=form.instance.pk)

    def get_formsets(self, data=None):
        """Initialize formsets with or without data."""
        self.chemical_data_form = ChemicalDataForm(data) if data else ChemicalDataForm()
        self.names_formset = (
            NamesFormSet(data, prefix="names") if data else NamesFormSet(queryset=Names.objects.none(), prefix="names")
        )
        self.database_accession_formset = (
            DatabaseAccessionFormSet(data, prefix="database-accession")
            if data
            else DatabaseAccessionFormSet(queryset=DatabaseAccession.objects.none(), prefix="database-accession")
        )
        self.compound_origins_formset = (
            CompoundOriginsFormSet(data, prefix="compound-origins")
            if data
            else CompoundOriginsFormSet(queryset=CompoundOrigins.objects.none(), prefix="compound-origins")
        )

    def validate_all_forms(self, *forms):
        all_valid = True
        for form in forms:
            if not form.is_valid():
                all_valid = False
        return all_valid

    def get(self, request, *args, **kwargs):
        self.get_formsets(data=None)
        return super().get(request, *args, **kwargs)

    def post(self, request, *args, **kwargs):
        """
        Handle POST requests: instantiate a form instance with the passed
        POST variables and then check if it's valid.
        """
        form = self.get_form()
        self.get_formsets(request.POST)
        if self.validate_all_forms(
            form,
            self.names_formset,
            self.database_accession_formset,
            self.chemical_data_form,
            self.compound_origins_formset,
        ):
            # If form and all nested forms are valid, then create the compound
            compound = form.save()
            # Initialise instances for nested forms
            database_accessions = self.database_accession_formset.save(commit=False)
            names = self.names_formset.save(commit=False)
            compound_origins = self.compound_origins_formset.save(commit=False)
            default_status = get_default_submitter_status()
            # Save nested formsets
            save_names_formset(names=names, compound=compound, status=default_status, created_by=request.user)
            save_compound_origins_formset(
                compound_origins=compound_origins, compound=compound, status=default_status, created_by=request.user
            )
            save_database_accessions_formset(
                database_accessions=database_accessions,
                compound=compound,
                status=default_status,
                created_by=request.user,
            )
            # Extract molfile of default structure and pass it to save_chemical_data
            self.chemical_data_form.save_with_structure(
                compound=compound,
                status=default_status,
                created_by=request.user,
                molfile=self.chemical_data_form.data.get("mol_default_structure"),
            )

            return self.form_valid(form)
        else:
            return self.form_invalid(form)

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs.update({"user": self.request.user})
        return kwargs

    def get_context_data(self, **kwargs):
        kwargs = super().get_context_data(**kwargs)
        kwargs.update({"chemical_data_form": self.chemical_data_form})
        kwargs.update({"names_formset": self.names_formset})
        kwargs.update({"database_accession_formset": self.database_accession_formset})
        kwargs.update({"compound_origins_formset": self.compound_origins_formset})
        return kwargs

templates/submitter/compound-detail/compound-origins.html
{% load custom_filters %}
<div class="d-flex justify-content-between align-items-center mb-3 mt-5">
    <p class="h4 mb-0">Species of Metabolite</p>
    <a href="{% url 'submitter:add-synonym' pk=compound.pk %}" class="btn btn-sm btn-outline-info">Add Species</a>
</div>
<table class="table table-striped table-hover table-responsive">
    <thead class="thead-dark">
    <tr>
      <th scope="col">Species</th>
      <th scope="col">Component</th>
      <th scope="col">Source</th>
      <th scope="col">Strain</th>
      <th scope="col">Comments</th>
      <th scope="col">Status</th>
      <th scope="col">Created On</th>
    </tr>
    </thead>
    <tbody>
    {% for compound in compound_with_children %}
        {% for x in compound.compound_origins.all %}
            <tr>
                <td>
                    {{ x.species_text }}
                    {% if x.species_accession %}
                        {% if x.species_source.url %}
                            (<a target="_blank" href="{{ x.species_source.url|cut:"*" }}{{ x.species_accession }}">{{ x.species_source.prefix }}:{{ x.species_accession }}</a>)
                        {% else %}
                            ({{ x.species_source.prefix }}:{{ x.species_accession }})
                        {% endif %}
                    {% endif %}
                </td>
                <td>
                    {% if x.component_text %}
                        {{ x.component_text }}
                        {% if x.component_accession %}
                            (<a target="_blank" href="https://purl.obolibrary.org/obo/{{ x.component_accession|format_component_accession }}">{{ x.component_accession }}</a>)
                        {% endif %}
                    {% else %}
                        -
                    {% endif %}
                </td>
            <td>
                {{ x.source }}
                {% if x.source_accession %}
                        {% if x.source.url %}
                            (<a target="_blank" href="{{ x.source.url|cut:"*" }}{{ x.source_accession }}">{{ x.source.prefix }}:{{ x.source_accession }}</a>)
                        {% else %}
                            ({{ x.source.prefix }}:{{ x.source_accession }})
                        {% endif %}
                    {% endif %}
            </td>
            <td>
                {{ x.strain_text|default:"-" }}
                {% if x.strain_accession %}
                    ({{ x.strain_accession }})
            {% endif %}
            </td>
            <td>
                {{ x.comments|default:"-" }}
            </td>
            <td>
                {{ x.status.name }}
            </td>
            <td>
                {{ x.created_on|date }}
            </td>
            </tr>
        {% endfor %}
    {% endfor %}
    </tbody>
</table>

templates/submitter/compound-detail/index.html
{% extends "base.html" %}
{% load static %}

{% block page_heading %}{{ compound.chebi_accession }}{% endblock %}

{% block content %}
    <div class="d-flex">
        <a href="{% url 'submitter:edit-entity' pk=compound.pk %}" class="btn btn-sm btn-outline-warning ms-auto">Edit Details</a>
    </div>

    <div class="row m-3">
        {% if default_structure_svg %}
            <div class="col-md-4 col-sm-12">
                {{ default_structure_svg|safe }}
            </div>
        {% endif %}
        <div class="col">
            <table class="table table-striped table-hover table-responsive">
                <tbody>
                <tr>
                    <th scope="row">ChEBI ID</th>
                    <td>{{ compound.chebi_accession }}</td>
                </tr>
                <tr>
                    <th scope="row">ChEBI Name</th>
                    <td>{{ compound.name|safe }}</td>
                </tr>
                <tr>
                    <th scope="row">ASCII Name</th>
                    <td>{{ compound.ascii_name }}</td>
                </tr>
                <tr>
                    <th scope="row">Stars</th>
                    <td>{{ compound.stars }}</td>
                </tr>
                <tr>
                    <th scope="row">Definition</th>
                    <td>{{ compound.definition }}</td>
                </tr>
                {% if compound.secondary_ids %}
                    <tr>
                        <th scope="row">Secondary IDs</th>
                        <td>
                            {% for x in compound.secondary_ids %}
                                {{ x }}{% if not forloop.last %}, {% endif %}
                            {% endfor %}
                        </td>
                    </tr>
                {% endif %}
                <tr>
                    <th scope="row">Created On</th>
                    <td>{{ compound.created_on|date }}</td>
                </tr>
                <tr>
                    <th scope="row">Created By</th>
                    <td>
                        {% for x in submitters %}
                        {{ x }}{% if not forloop.last %}, {% endif %}
                        {% endfor %}
                    </td>
                </tr>
                <tr>
                    <th scope="row">Modified On</th>
                    <td>{{ compound.modified_on|date }}</td>
                </tr>
                {% if compound.release_date %}
                    <tr>
                        <th scope="row">Released On</th>
                        <td>{{ compound.release_date|date }}</td>
                    </tr>
                {% endif %}
                <tr>
                    <th scope="row">Source</th>
                    <td>{{ compound.source }}</td>
                </tr>
                {% if compound.submitter_notes %}
                <tr>
                    <th scope="row">Submitter Notes</th>
                    <td>{{ compound.submitter_notes }}</td>
                </tr>
                {% endif %}
                </tbody>
            </table>
        </div>
    </div>

    {% if compound.chemical_data or compound.default_structure %}
    <div class="row m-3 mt-5">
        <div class="d-flex justify-content-between align-items-center mb-3">
            <p class="h4 mb-0">Chemical Data</p>
            {% if compound.default_structure %}
                <a target="_blank" href="{% url 'public_api:download_molfile' pk=compound.pk %}" class="btn btn-sm btn-outline-info">Download Molfile</a>
            {% endif %}
        </div>
        <table class="table table-striped table-hover table-responsive">
            <tbody>
            {% if compound.chemical_data %}
                <tr>
                    <th scope="row">Formula</th>
                    <td>{{ compound.chemical_data.formula }}</td>
                </tr>
                <tr>
                    <th scope="row">Net Charge</th>
                    <td>{{ compound.chemical_data.charge }}</td>
                </tr>
                <tr>
                    <th scope="row">Average Mass</th>
                    <td>{{ compound.chemical_data.mass }}</td>
                </tr>
                <tr>
                    <th scope="row">Monoisotopic Mass</th>
                    <td>{{ compound.chemical_data.monoisotopic_mass }}</td>
                </tr>
                <tr>
                    <th scope="row">Autogenerated</th>
                    <td>{{ compound.chemical_data.is_autogenerated }}</td>
                </tr>
            {% endif %}

            {% if compound.default_structure %}
                <tr>
                    <th scope="row">SMILES</th>
                    <td>{{ compound.default_structure.smiles }}</td>
                </tr>
                <tr>
                    <th scope="row">InChI</th>
                    <td>{{ compound.default_structure.standard_inchi }}</td>
                </tr>
                <tr>
                    <th scope="row">InChIKey</th>
                    <td>{{ compound.default_structure.standard_inchi_key }}</td>
                </tr>
            {% endif %}
            </tbody>
        </table>
    {% endif %}

    {% include 'submitter/compound-detail/names.html' %}
    {% include 'submitter/compound-detail/xrefs.html' %}
    {% include 'submitter/compound-detail/compound-origins.html' %}

    </div>
{% endblock %}

{% block script %}
    <link rel="stylesheet" href="{% static 'css/submitter.css' %}">
{% endblock %}

templates/submitter/compound-detail/names.html
<div class="d-flex justify-content-between align-items-center mb-3 mt-5">
    <span class="h4 mb-0">Synonyms</span>
    <a href="{% url 'submitter:add-synonym' pk=compound.pk %}" class="btn btn-sm btn-outline-info">Add Synonym</a>
</div>

<table class="table table-striped table-hover table-responsive">
    <thead class="thead-dark">
    <tr>
      <th scope="col">Type</th>
      <th scope="col">Name</th>
      <th scope="col">Status</th>
      <th scope="col">Source</th>
      <th scope="col">Language</th>
      <th scope="col">Created On</th>
      <th scope="col"></th>
    </tr>
    </thead>
    <tbody>
    {% for compound in compound_with_children %}
    {% for name in compound.names.all %}
        <tr>
            <td>{{ name.type }}</td>
            <td>{{ name.name }}</td>
            <td>{{ name.status.name }}</td>
            <td>{{ name.source }}</td>
            <td>{{ name.language_code }}</td>
            <td>{{ name.created_on|date  }}</td>
            <td class="small-td">
                <a href="{% url 'submitter:name-update' pk=name.pk %}" class="link-underline-light">Edit</a>
            </td>
        </tr>
    {% endfor %}
    {% endfor %}
    </tbody>
</table>

templates/submitter/compound-detail/xrefs.html
<div class="d-flex justify-content-between align-items-center mb-3 mt-5">
    <span class="h4 mb-0">Cross-References</span>
    <a href="{% url 'submitter:add-xref' pk=compound.pk %}" class="btn btn-sm btn-outline-info">Add Cross Reference</a>
</div>

<table class="table table-striped table-hover table-responsive">
    <thead class="thead-dark">
    <tr>
      <th scope="col">Type</th>
      <th scope="col">Accession No</th>
      <th scope="col">Status</th>
      <th scope="col">Source</th>
      <th scope="col">Created On</th>
      <th scope="col"></th>
    </tr>
    </thead>
    <tbody>
    {% for compound in compound_with_children %}
        {% for x in compound.database_accessions.all %}
            <tr>
                <td>{{ x.type }}</td>
                <td>
                    {% if x.source.url %}
                        <a target="_blank" href="{{ x.source.url|cut:"*" }}{{ x.accession_number }}">{{ x.source.prefix }}:{{ x.accession_number }}</a>
                    {% else %}
                        {{ x.accession_number }}
                    {% endif %}
                </td>
                <td>{{ x.status.name }}</td>
                <td>{{ x.source }}</td>
                <td>{{ x.created_on|date  }}</td>
                <td class="small-td">
                    <a href="{% url 'submitter:update-xref' pk=x.pk %}" class="link-underline-light">Edit</a>
                </td>
            </tr>
        {% endfor %}
    {% endfor %}
    </tbody>
</table>